                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*  version 7: iterative constructs  */
                     /*-----------------------------------*/
                     /*               memory              */
                     /*-----------------------------------*/

/*------------------------------ public types --------------------------------*/

typedef           void * ADR_type;
typedef  unsigned long   CEL_type;
typedef unsigned short   BYT_type;
typedef           char   CHR_type;
typedef         double   FLO_type;
typedef       long int   LNG_type;
typedef           void   NIL_type;
typedef    signed long   SGN_type;
typedef           char * TXT_type;
typedef  unsigned long   UNS_type;

typedef union PTR { CEL_type    cel;
                    union PTR * ptr; } * PTR_type;

/*------------------------------ public constants ----------------------------*/

static const UNS_type Memory_Cell_Size = sizeof(CEL_type);

/*------------------------------ public prototypes ---------------------------*/

UNS_type   Memory_Get_Size(PTR_type);
BYT_type    Memory_Get_Tag(PTR_type);
NIL_type Memory_Initialize(ADR_type,
                           UNS_type);
PTR_type Memory_Make_Chunk(BYT_type,
                           UNS_type);